package edu.ksu.cis.ndpc;

public abstract class LangSymbols {
	public static final int S_INV = -1;

	public static final int S_PRED = 0;
	public static final int S_IMPL = 1;
	public static final int S_DIMPL = 2;
	public static final int S_DISJ = 3;
	public static final int S_CONJ = 4;
	public static final int S_NEG = 5;
	public static final int S_OPAR = 6;
	public static final int S_CPAR = 7;
	public static final int S_NULL = 8;
	public static final int S_BOTTOM = 9;
	public static final int S_CONST = 10;
	public static final int S_FUNC = 11;
	public static final int S_VAR = 12;
	public static final int S_FORALL = 13;
	public static final int S_EXISTS = 14;
	public static final int S_EQUAL = 15;

	public static final int S_ATOM = 0;
	// public static final int S_FREE = 20;
	public static final int S_COMMA = 21;

	public static final int ASSOC_LEFT = -1;
	public static final int ASSOC_AMBIG = 0;
	public static final int ASSOC_RIGHT = 1;

	public static final int PRECE_LOWER = -1;
	public static final int PRECE_EQUAL = 0;
	public static final int PRECE_HIGHER = 1;

	public abstract String[] getSpecialSymbols();

	public abstract int identify(String symbol);

	public abstract boolean exists(String symbol);
}
