package edu.ksu.cis.ndpc;

/**
 * @author Brian Mulanda
 *
 */

import java.util.ArrayList;

public class ProofBox {
	private ArrayList variables;
	private int boxId;

	public ProofBox(int boxId) {
		this.boxId = boxId;
		this.variables = new ArrayList();
	}

	public String toString() {
		return "BOX:" + boxId;
	}

	public void addFreshVariable(Symbol v) {
		variables.add(v);
	}

	public boolean introduces(Symbol v) {
		return (v != null && variables.contains(v));
	}
}