package edu.ksu.cis.ndpc.gui;

import java.awt.Point;

public class Boundary {
	public int x1;
	public int x2;
	public int y1;
	public int y2;

	public Boundary() {
		this(0, 0, 0, 0);
	}

	public Boundary(int x1, int y1, int x2, int y2) {
		set(x1, y1, x2, y2);
	}

	public void set(int x1, int y1, int x2, int y2) {
		this.x1 = x1;
		this.x2 = x2;
		this.y1 = y1;
		this.y2 = y2;
	}

	public boolean containsPoint(Point p) {
		return containsPoint(p.x, p.y);
	}

	public boolean containsPoint(int x, int y) {
		return (x >= x1 && x <= x2 && y >= y1 && y <= y2);
	}

	public String toString() {
		return "Bounds[" + x1 + "," + y1 + "," + x2 + "," + y2 + "]";
	}

}
